/*
 * generated by Xtext 2.11.0
 */
package com.mncml.implementation.pogo.serializer;

import com.google.inject.Inject;
import com.mncml.implementation.pogo.services.SimulatorDslGrammarAccess;
import java.util.Set;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Parameter;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.serializer.ISerializationContext;
import org.eclipse.xtext.serializer.sequencer.AbstractDelegatingSemanticSequencer;
import tangoSimLibSimulator.CommandSimulation;
import tangoSimLibSimulator.ConstantQuantity;
import tangoSimLibSimulator.DataSimulation;
import tangoSimLibSimulator.DeterministicSignal;
import tangoSimLibSimulator.GaussianSlewLimited;
import tangoSimLibSimulator.InputTransform;
import tangoSimLibSimulator.OutputReturn;
import tangoSimLibSimulator.OverrideClass;
import tangoSimLibSimulator.RuntimeSpecifiedWaveform;
import tangoSimLibSimulator.SideEffects;
import tangoSimLibSimulator.TangoSimLib;
import tangoSimLibSimulator.TangoSimLibSimulatorPackage;

@SuppressWarnings("all")
public class SimulatorDslSemanticSequencer extends AbstractDelegatingSemanticSequencer {

	@Inject
	private SimulatorDslGrammarAccess grammarAccess;
	
	@Override
	public void sequence(ISerializationContext context, EObject semanticObject) {
		EPackage epackage = semanticObject.eClass().getEPackage();
		ParserRule rule = context.getParserRule();
		Action action = context.getAssignedAction();
		Set<Parameter> parameters = context.getEnabledBooleanParameters();
		if (epackage == TangoSimLibSimulatorPackage.eINSTANCE)
			switch (semanticObject.eClass().getClassifierID()) {
			case TangoSimLibSimulatorPackage.COMMAND_SIMULATION:
				sequence_CommandSimulation(context, (CommandSimulation) semanticObject); 
				return; 
			case TangoSimLibSimulatorPackage.CONSTANT_QUANTITY:
				sequence_ConstantQuantity(context, (ConstantQuantity) semanticObject); 
				return; 
			case TangoSimLibSimulatorPackage.DATA_SIMULATION:
				sequence_DataSimulation(context, (DataSimulation) semanticObject); 
				return; 
			case TangoSimLibSimulatorPackage.DETERMINISTIC_SIGNAL:
				sequence_DeterministicSignal(context, (DeterministicSignal) semanticObject); 
				return; 
			case TangoSimLibSimulatorPackage.GAUSSIAN_SLEW_LIMITED:
				sequence_GaussianSlewLimited(context, (GaussianSlewLimited) semanticObject); 
				return; 
			case TangoSimLibSimulatorPackage.INPUT_TRANSFORM:
				sequence_InputTransform(context, (InputTransform) semanticObject); 
				return; 
			case TangoSimLibSimulatorPackage.OUTPUT_RETURN:
				sequence_OutputReturn(context, (OutputReturn) semanticObject); 
				return; 
			case TangoSimLibSimulatorPackage.OVERRIDE_CLASS:
				sequence_OverrideClass(context, (OverrideClass) semanticObject); 
				return; 
			case TangoSimLibSimulatorPackage.RUNTIME_SPECIFIED_WAVEFORM:
				sequence_RuntimeSpecifiedWaveform(context, (RuntimeSpecifiedWaveform) semanticObject); 
				return; 
			case TangoSimLibSimulatorPackage.SIDE_EFFECTS:
				sequence_SideEffects(context, (SideEffects) semanticObject); 
				return; 
			case TangoSimLibSimulatorPackage.TANGO_SIM_LIB:
				sequence_TangoSimLib(context, (TangoSimLib) semanticObject); 
				return; 
			}
		if (errorAcceptor != null)
			errorAcceptor.accept(diagnosticProvider.createInvalidContextOrTypeDiagnostic(semanticObject, context));
	}
	
	/**
	 * Contexts:
	 *     CommandSimulation returns CommandSimulation
	 *
	 * Constraint:
	 *     (pogoCommand=[Command|QualifiedName] behaviorType=Behaviour?)
	 */
	protected void sequence_CommandSimulation(ISerializationContext context, CommandSimulation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Simulation returns ConstantQuantity
	 *     ConstantQuantity returns ConstantQuantity
	 *
	 * Constraint:
	 *     (initialValue=EFloat? quality=EFloat?)
	 */
	protected void sequence_ConstantQuantity(ISerializationContext context, ConstantQuantity semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     DataSimulation returns DataSimulation
	 *
	 * Constraint:
	 *     (pogoAttr=[Attribute|QualifiedName]? simulationType=Simulation?)
	 */
	protected void sequence_DataSimulation(ISerializationContext context, DataSimulation semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Simulation returns DeterministicSignal
	 *     DeterministicSignal returns DeterministicSignal
	 *
	 * Constraint:
	 *     (type=EString? amplitude=EFloat? period=EInt? offset=EFloat?)
	 */
	protected void sequence_DeterministicSignal(ISerializationContext context, DeterministicSignal semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Simulation returns GaussianSlewLimited
	 *     GaussianSlewLimited returns GaussianSlewLimited
	 *
	 * Constraint:
	 *     (minBound=EFloat? maxBound=EFloat? mean=EFloat? slewRate=EFloat? updatePeriod=EFloat?)
	 */
	protected void sequence_GaussianSlewLimited(ISerializationContext context, GaussianSlewLimited semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Behaviour returns InputTransform
	 *     InputTransform returns InputTransform
	 *
	 * Constraint:
	 *     destinationVariableName=EString?
	 */
	protected void sequence_InputTransform(ISerializationContext context, InputTransform semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Behaviour returns OutputReturn
	 *     OutputReturn returns OutputReturn
	 *
	 * Constraint:
	 *     (source_variable=EString? source_quantity=EString?)
	 */
	protected void sequence_OutputReturn(ISerializationContext context, OutputReturn semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     OverrideClass returns OverrideClass
	 *
	 * Constraint:
	 *     (name=STRING? module_directory=EString? module_name=EString? class_name=EString?)
	 */
	protected void sequence_OverrideClass(ISerializationContext context, OverrideClass semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Simulation returns RuntimeSpecifiedWaveform
	 *     RuntimeSpecifiedWaveform returns RuntimeSpecifiedWaveform
	 *
	 * Constraint:
	 *     (defaultValue=EFloat? timestamp=EString? attribute_qualities=EFloat?)
	 */
	protected void sequence_RuntimeSpecifiedWaveform(ISerializationContext context, RuntimeSpecifiedWaveform semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     Behaviour returns SideEffects
	 *     SideEffects returns SideEffects
	 *
	 * Constraint:
	 *     (source_variable=EString? destination_quantity=EString?)
	 */
	protected void sequence_SideEffects(ISerializationContext context, SideEffects semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
	/**
	 * Contexts:
	 *     TangoSimLib returns TangoSimLib
	 *
	 * Constraint:
	 *     (
	 *         refferedPogoDeviceClass=[PogoDeviceClass|QualifiedName]? 
	 *         (dataSimulations+=DataSimulation dataSimulations+=DataSimulation*)? 
	 *         (commandSimulations+=CommandSimulation commandSimulations+=CommandSimulation*)? 
	 *         (overrideClass+=OverrideClass overrideClass+=OverrideClass*)?
	 *     )
	 */
	protected void sequence_TangoSimLib(ISerializationContext context, TangoSimLib semanticObject) {
		genericSequencer.createSequence(context, semanticObject);
	}
	
	
}
